<template>
  <div class="w-100">
    <div class="my-4">
      <h4 class="mt-0 mb-3">Reset your password</h4>
    </div>

    <form @submit.prevent="resetPassword">
      <div id="error-message" v-if="errors.serverSideErrorMessage">
        <span>
          {{ errors.serverSideErrorMessage }}
        </span>
      </div>

      <template v-if="canResetPassword">
        <template v-if="passwordReseted">
          <div class="mb-3">Your password has successfully been reseted.</div>

          <div class="form-group mb-0 text-center">
            <router-link
              :to="{ name: 'Login' }"
              class="btn btn-primary btn-block btn-submit w-100"
              >Login</router-link
            >
          </div>
        </template>

        <template v-else>
          <div class="form-group mb-3">
            <label for="password">New password</label>
            <input
              id="password"
              class="form-control"
              type="password"
              placeholder="New Password"
              v-model="credentials.password"
              required
            />
            <span class="text-danger" v-if="errors.passwordErrorMessage">
              {{ errors.passwordErrorMessage }}
            </span>
          </div>

          <div class="form-group mb-3">
            <label for="confirm-password">Confirm new password</label>
            <input
              id="confirm-password"
              class="form-control"
              type="password"
              placeholder="Confirm new password"
              v-model="credentials.confirmPassword"
              required
            />
            <span class="text-danger" v-if="errors.confirmPasswordErrorMessage">
              {{ errors.confirmPasswordErrorMessage }}
            </span>
          </div>

          <div class="form-group mb-0 text-center">
            <button
              class="btn btn-primary btn-block btn-submit w-100"
              type="submit"
              :disabled="submitting"
            >
              Reset my password
            </button>
          </div>
        </template>
      </template>
    </form>
  </div>
</template>

<script>
import { EVENT_MANAGER_APP_BASE_URL } from "@/configs";

export default {
  name: "reset-password-page",
  data: () => ({
    loading: false,
    submitting: false,
    canResetPassword: false,
    passwordReseted: false,
    redirectLink: null,
    credentials: {
      email: null,
      password: null,
      confirmPassword: null,
    },
    errors: {
      passwordErrorMessage: null,
      confirmPasswordErrorMessage: null,
      serverSideErrorMessage: null,
    },
  }),
  methods: {
    clearForm() {
      this.credentials.email = null;
      this.credentials.password = null;
      this.credentials.confirmPassword = null;
    },
    clearErrorsMessages() {
      this.errors.passwordErrorMessage = null;
      this.errors.confirmPasswordErrorMessage = null;
      this.errors.serverSideErrorMessage = null;
    },
    async getUserByResetToken(token) {
      this.$store
        .dispatch("admin/fetchAdminByResetToken", {
          token,
          services: this.$services,
        })
        .then((response) => {
          this.credentials.email = response.admin.email;
          this.submitting = false;
          this.canResetPassword = true;
        })
        .catch((err) => {
          console.log(err.response);
          if (err.response.status === 403) {
            this.errors.serverSideErrorMessage = err.response.data.message;
          } else if (err.response.status === 422) {
            for (const error of err.response.data.data) {
              if (error.field == "email") {
                this.errors.serverSideErrorMessage = error.message;
              }
            }
          } else {
            this.errors.serverSideErrorMessage =
              "Something went wrong. Please try again later!";
          }
          this.canResetPassword = false;
          this.submitting = false;
        });
    },
    async sendPasswordResetMail() {
      this.clearErrorsMessages();

      this.submitting = true;
      this.$services.AuthService.sendPasswordResetMail({
        email: this.credentials.email,
        redirectLink: this.redirectLink,
      })
        .then(() => {
          this.emailSent = true;
          this.submitting = false;
        })
        .catch((err) => {
          if (err.response.status === 403) {
            this.errors.serverSideErrorMessage = err.response.data.message;
          } else if (err.response.status === 422) {
            for (const error of err.response.data.data) {
              if (error.field == "email") {
                this.errors.serverSideErrorMessage = error.message;
              }
            }
          } else {
            this.errors.serverSideErrorMessage =
              "Something went wrong. Please try again later!";
          }
          this.submitting = false;
        });
    },
    async resetPassword() {
      this.clearErrorsMessages();

      this.submitting = true;
      this.$services.AuthService.resetPassword(this.credentials)
        .then(({ data }) => {
          console.log(data);
          this.submitting = false;
          this.passwordReseted = true;
        })
        .catch((err) => {
          if (err.response.status === 404) {
            this.errors.serverSideErrorMessage = err.response.data.message;
          } else if (err.response.status === 422) {
            for (const error of err.response.data.data) {
              if (error.field == "password") {
                this.errors.passwordErrorMessage = error.message;
              } else if (error.field == "confirmPassword") {
                this.errors.confirmPasswordErrorMessage = error.message;
              }
            }
          } else {
            this.errors.serverSideErrorMessage =
              "Something went wrong. Please try again later!";
          }
          this.submitting = false;
        });
    },
  },
  created() {
    this.loading = true;
    const query = this.$route.query;

    if (!query.hasToken) {
      this.canResetPassword = false;
      this.loading = false;
      return;
    }

    const allRoutes = this.$router.getRoutes();
    this.redirectLink = `${
      EVENT_MANAGER_APP_BASE_URL +
      "" +
      allRoutes.find((route) => route.name == "ResetPassword").path
    }`;

    this.getUserByResetToken(query.token);
  },
};
</script>

<style>
</style>